package com.iden.bms.service;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.iden.common.entity.IdenSysRole;
import com.iden.common.service.IdenSysRoleService;
import com.iden.common.util.MyBeanUtils;
import com.iden.common.vo.SysRoleVO;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLogindConvertVO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class SysRoleService {

    @Resource
    private IdenSysRoleService idenSysRoleService;

    

    /**
     * 查询角色列表
     * @return
             */
    public IPage<SysRoleVO> listSysRole(UserLogindConvertVO loginUser, PageReqVO pageReqVo) {
            IPage<IdenSysRole> page = new Page<>(pageReqVo.getCurrent(), pageReqVo.getPageSize());
            QueryWrapper<IdenSysRole> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().orderByAsc(IdenSysRole::getCode);

            IPage<IdenSysRole> pageRes = this.idenSysRoleService.page(page, queryWrapper);
            IPage<SysRoleVO> results = new Page<>(pageRes.getCurrent(),pageRes.getSize(),pageRes.getTotal());
            if(CollUtil.isNotEmpty(pageRes.getRecords())){
                List<SysRoleVO> list = new ArrayList<>();
                pageRes.getRecords().forEach(item -> {
                    SysRoleVO resVO = new SysRoleVO();
                    BeanUtils.copyProperties(item,resVO);
                    list.add(resVO);
                });
                results.setRecords(list);
            }
            return results;
    }

    /**
     * 删除角色
     * @param id
     * @return
     */
    public boolean deleteById(Long id){
        return this.idenSysRoleService.removeById(id);
    }

    /**
     * 详情
     * @param id
     * @return
     */
    public SysRoleVO getSysRoleById(Long id){
        IdenSysRole idenSysRole = this.idenSysRoleService.getById(id);
        if (idenSysRole!=null){
            SysRoleVO resVO = new SysRoleVO();
            BeanUtil.copyProperties(idenSysRole,resVO);
            return resVO;
        }
        return null;
    }


    /**
     * 保存角色
     * @param vo
     */
    @Transactional(rollbackFor = Exception.class)
    public int createSysRole(SysRoleVO vo, UserLogindConvertVO loginUser){
        QueryWrapper<IdenSysRole> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(IdenSysRole::getName,vo.getName());
        if(idenSysRoleService.count(queryWrapper) > 0){
            return 1;
        }
        QueryWrapper<IdenSysRole> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.lambda().eq(IdenSysRole::getCode,vo.getCode());
        if(idenSysRoleService.count(queryWrapper2) > 0){
            return 2;
        }
        //保存角色
        IdenSysRole idenSysRole = new IdenSysRole();
        BeanUtil.copyProperties(vo,idenSysRole);
        idenSysRole.setCreateTime(new Date());

        this.idenSysRoleService.save(idenSysRole);
        return 0;
    }

    /**
     * 修改角色
     * @param vo
     */
    @Transactional(rollbackFor = Exception.class)
    public void updateSysRole(SysRoleVO vo){
        //保存角色
        IdenSysRole idenSysRole = this.idenSysRoleService.getById(vo.getId());
        MyBeanUtils.copyProperties(vo,idenSysRole);
        idenSysRole.setModifyTime(new Date());
        this.idenSysRoleService.updateById(idenSysRole);

    }

}